<template>
  <b-container fluid>
    <b-row>
      <b-col>
        <b-button @click="exportExcel">
          Exportar a excel
        </b-button>
      </b-col>
    </b-row>
    <b-row>
      <b-col class="d-flex justify-content-between col-lg-10 col-12">
        <VRoleFilter
          v-if="shipping_mode == 'normal'"
          label="Rol del receptor"
          v-model="filters.request__consumer__role"
          @change="$refs.table_shipping.refresh()"
        />
        <VRoleFilter
          v-if="shipping_mode == 'move'"
          label="Rol del proveedor"
          v-model="filters.move__owner__role"
          @change="$refs.table_shipping.refresh()"
        />
        <VRoleFilter
          label="Rol del proveedor"
          v-model="filters.inventory__owner__role"
          @change="$refs.table_shipping.refresh()"
        />
        <VShippingStatusFilter
          label="Estado del envío"
          v-model="filters.status"
          @change="$refs.table_shipping.refresh()"
        />
        <b-form-group
          label-cols="12"
          label-cols-sm="12"
          label-cols-md="12"
          label-cols-lg="12"
          label-cols-xl="12"
          label="Después de la fecha"
          label-for="datepicker-date-after"
        >
          <b-form-datepicker
            id="datepicker-date-after"
            today-button
            reset-button
            close-button
            locale="es"
            v-model="filters.created_date_after"
            @input="$refs.table_shipping.refresh()"
          ></b-form-datepicker>
        </b-form-group>
        <b-form-group
          label-cols="12"
          label-cols-sm="12"
          label-cols-md="12"
          label-cols-lg="12"
          label-cols-xl="12"
          label="Antes de la fecha"
          label-for="datepicker-date-before"
        >
          <b-form-datepicker
            id="datepicker-date-before"
            today-button
            reset-button
            close-button
            locale="es"
            v-model="filters.created_date_before"
            @input="$refs.table_shipping.refresh()"
          ></b-form-datepicker>
        </b-form-group>

      </b-col>
    </b-row>
    <b-row
      class="border"
    >
      <b-col cols="4">
        <b-button
          v-if="!$_.isEmpty(selectedRows)"
          size="sm"
          variant="primary"
          class="m-2"
          v-b-toggle.bulk-colapse
        >
          <b-icon icon="list-check" aria-hidden="true"></b-icon>
        </b-button>
        <b-button
          v-else
          v-b-popover.hover.top="'Selecciona alguans filas para realizar acciones en bloque'"
          size="sm"
          variant="secondary"
          class="m-2"
        >
          <b-icon icon="list-check" aria-hidden="true"></b-icon>
        </b-button>
        <b-collapse
          ref="bulk_colapse"
          id="bulk-colapse"
          class="mt-2"
          v-model="bulkCollapseVisible"
        >
          <div class="p-2">
            <h4>
              Marcar selección como:
            </h4>
            <VShippingStatusFilter
              label="Estado del envío"
              v-model="bulkSetStatus"
            />
            <b-button
              :disabled="bulkSetStatus === null || bulkSetStatus === undefined"
              variant="danger"
              @click="onBulkButtonClick"
            >
              Marcar
            </b-button>
          </div>
        </b-collapse>
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12">
        <b-button
          class="mt-4"
          size="sm"
          variant="outline-secondary"
          @click="refresh()"
        >
          <b-icon icon="arrow-repeat" aria-hidden="true"></b-icon>
        </b-button>
        <b-table
          ref="table_shipping"
          :fields="fields"
          responsive
          hover
          stacked="sm"
          :busy.sync="isBusy"
          :sort-by.sync="sortBy"
          :sort-desc.sync="sortDesc"
          no-local-sorting
          :items="tableProvider"
          :current-page="currentPage"
          :per-page="perPage"
          @row-selected="onRowSelected"
          selectable
          select-mode="multi"
          selected-variant="warning"
        >
          <template v-slot:cell(selected)="{ rowSelected }">
            <template v-if="rowSelected">
              <b-icon icon="check-box" variant="success"></b-icon>
            </template>
            <template v-else>
              <b-icon icon="square"></b-icon>
            </template>
          </template>
          <template v-slot:cell(status)="data">
            {{ mappedAvailShippingStatuses[data.item.status] }}
            <b-icon
              v-if="data.item._loading"
              icon="arrow-clockwise"
              animation="spin"
            ></b-icon>
            <b-icon
              v-if="data.item._error"
              icon="exclamation-triangle"
              variant="danger"
              v-b-popover.hover.top="'Hubo un error al guardar esta fila'"
            ></b-icon>
          </template>
          <template v-slot:cell(carrier__name)="data">
            {{ $_.get(data, 'item.carrier_object.name', '') }}
          </template>
          <template v-slot:cell(request__consumer__name)="data">
            <span v-if="$_.get(data, 'item.request', null)">
              {{ $_.get(data, 'item.request_object.consumer_object.name', '') }}
            </span>
            <span v-if="$_.get(data, 'item.move', null)">
              {{ $_.get(data, 'item.move_object.owner_object.name', '') }}
            </span>
          </template>
          <template v-slot:cell(inventory__owner__name)="data">
            {{ $_.get(data, 'item.inventory_object.owner_object.name', '') }}
          </template>
          <template v-slot:cell(actions)="data">
            <b-button
              variant="secondary"
              size="sm"
              @click="editShipping(data.item)"
            >
              Editar
            </b-button>
          </template>
          <template v-slot:cell(uuid)="data">
            <span
              :id="'tooltip-target-' + data.item.uuid"
            >
              {{ data.item.uuid.split("-")[0] }}
            </span>
            <b-tooltip
              :target="'tooltip-target-' + data.item.uuid"
              triggers="hover"
            >
              {{ data.item.uuid }}
            </b-tooltip>
          </template>
        </b-table>
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12 text-center">
        <b-pagination
          align="center"
          :total-rows="totalRows"
          :per-page="perPage"
          v-model="currentPage"
        />
      </b-col>
    </b-row>
    <b-modal ref="shipping_modal" centered size="xl" title="Envío" hide-footer>
      <ShippingForm
        v-if="shipping_preset_form"
        :shipping_mode="shipping_form_mode"
        :preset_form="shipping_preset_form"
        @cancel="$refs.shipping_modal.hide()"
        @saved="onShippingSaved"
      />
    </b-modal>
  </b-container>
</template>

<script>
import { mapState, mapActions } from "vuex";
import VRoleFilter from "@/components/VRoleFilter";
import ShippingForm from "@/components/ShippingForm";

import VShippingStatusFilter from "@/components/VShippingStatusFilter";

export default {
  name: "shipping-list",
  components: {
    VRoleFilter,
    VShippingStatusFilter,
    ShippingForm
  },
  props: {
    preset_filters: {
      type: Object,
      default: undefined
    },
    shipping_mode: {
      type: String,
      default: "normal"
    }
  },
  data() {
    return {
      shipping_preset_form: undefined,
      filters: {
        request__consumer__role: null,
        move__owner__role: null,
        inventory__owner__role: null,
        status: null,
        created_date_after: null,
        created_date_before: null
      },
      loading: false,
      isBusy: false,
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      sortBy: null,
      sortDesc: false,
      availRoles: undefined,
      mappedAvailRoles: [],
      shipping_form_mode: "normal",
      selectedRows: [],
      bulkSetStatus: undefined,
      bulkCollapseVisible: false
    };
  },
  computed: {
    ...mapState({
      availShippingStatuses: state => state.utils.availShippingStatuses,
      mappedAvailShippingStatuses: state =>
        state.utils.mappedAvailShippingStatuses
    }),
    fields() {
      return [
        {
          key: "selected",
          label: ""
        },
        {
          key: "pk",
          label: "ID",
          sortable: true
        },
        {
          key: "created_date",
          label: "Fecha de creación",
          sortable: true,
          formatter: value => {
            return this.$formatDate(value);
          }
        },
        {
          key: "uuid",
          label: "Id único",
          sortable: true
        },
        {
          key: "status",
          label: "Estado",
          sortable: true
        },
        {
          key: "carrier__name",
          label: "Transportista",
          sortable: true
        },
        {
          key: "inventory__owner__name",
          label: "Proveedor",
          sortable: true
        },
        {
          key: "request__consumer__name",
          label: "Demandante",
          sortable: true
        },
        {
          key: "request",
          label: "Pedido",
          sortable: true
        },
        {
          key: "quantity",
          label: "Cantidad total",
          sortable: true
        },
        {
          key: "actions",
          label: "",
          sortable: false
        }
      ];
    }
  },
  mounted() {
    if (!this.availRequestStatuses) {
      this.LOAD_AVAIL_SHIPPING_STATUSES();
    }
    if (this.preset_filters) {
      this.filters = Object.assign({}, this.filters, this.preset_filters);
    }
  },
  methods: {
    ...mapActions({
      LOAD_AVAIL_SHIPPING_STATUSES: "utils/LOAD_AVAIL_SHIPPING_STATUSES",
      PATCH_SHIPPING: "shipping/PATCH_SHIPPING"
    }),
    getFilters() {
      let offset = 0;
      var filters = {};
      if (this.perPage && this.currentPage) {
        offset = this.perPage * (this.currentPage - 1);
      }
      filters.offset = offset;
      filters.limit = this.perPage;
      if (this.sortBy) {
        filters["ordering"] = this.sortBy;
        if (this.sortDesc) {
          filters["ordering"] = "-" + filters["ordering"];
        }
      }
      filters = Object.assign(filters, this.filters);
      return filters;
    },
    exportExcel() {
      let filters = this.getFilters();
      filters["export"] = 0;
      const uri = this.$parseurl(
        "/logistica/middle/person/{person_pk}/shipping/",
        {
          person_pk: localStorage.getItem("pk_person")
        },
        filters
      );
      // TODO: workaround to download blob, improvement required
      // https://stackoverflow.com/questions/32545632/how-can-i-download-a-file-using-window-fetch
      this.$fetchget(uri)
        .then(response => response.blob())
        .then(blob => {
          var url = window.URL.createObjectURL(blob);
          var a = document.createElement("a");
          a.href = url;
          a.download = "export.xls";
          document.body.appendChild(a);
          a.click();
          a.remove();
        });
    },
    tableProvider() {
      this.loading = false;
      const filters = this.getFilters();
      const uri = this.$parseurl(
        "/logistica/middle/person/{person_pk}/shipping/",
        {
          person_pk: localStorage.getItem("pk_person")
        },
        filters
      );
      return new Promise((resolve, reject) => {
        this.$fetchget(uri).then(res => {
          res.json().then(data => {
            if (res.ok) {
              const items = data.results;
              this.loading = false;
              this.totalRows = data.count;
              resolve(items);
              return items;
            } else {
              // TODO: LANZAR ERROR
              reject("error");
            }
          });
        });
      });
    },
    onBulkButtonClick() {
      this.isBusy = true;

      let promises = [];
      this.selectedRows.forEach(element => {
        element._loading = true;
        element._error = false;
        promises.push(
          this.PATCH_SHIPPING({
            person_pk: localStorage.getItem("pk_person"),
            shipping_pk: element.pk,
            data: { status: this.bulkSetStatus }
          }).then(
            res => {
              element._loading = false;
              element.status = res.data.status;
            },
            () => {
              element._error = true;
              element._loading = false;
            }
          )
        );
      });

      Promise.all(promises).then(
        () => {
          this.isBusy = false;
        },
        () => {
          this.isBusy = false;
        }
      );
    },
    editShipping(shipping) {
      if (shipping.request) {
        this.shipping_form_mode = "normal";
      } else if (shipping.move) {
        this.shipping_form_mode = "move";
      } else {
        return;
      }
      this.shipping_preset_form = shipping;
      this.$refs.shipping_modal.show();
    },
    onShippingSaved() {
      this.$refs.shipping_modal.hide();
      this.$refs.table_shipping.refresh();
    },
    onRowSelected(items) {
      this.selectedRows = items;
      if (this.$_.isEmpty(items)) {
        this.bulkCollapseVisible = false;
        // this.$refs.bulk_colapse.close();
        // this.$root.$emit("bv::toggle::collapse", "bulk-colapse").close();
      }
    },
    refresh() {
      this.$refs.table_shipping.refresh();
    }
  }
};
</script>
<style>
</style>
